# ==============================================================================
#                Collapser used in uiScriptPy Lib
#  ----------------------------------------------------------------------------
#  Subclass of the more general basic_comtainer class
#
#  Collapser conmtainer type can hold other UiScriptContainer and uiScriptGadgets
# ==============================================================================

from enums        import *
from base_classes import *
from basic_container_class import *

class CollapserUiScriptContainer(BasicUiScriptContainer):
  
	def __init__(self, name, label, uiScriptGadgets=(), collapsed=False):
	  
		self.setName(name)
		self.setVStretch(1)
		self.setUiScriptGadgets(uiScriptGadgets)
		self.setIsCollapsed(collapsed)

		self._basic_container_type = uiScriptBasicContainerType.collapser
		self._container_type       = self._basic_container_type

		# no label so default to name
		if label == None: self.setLabel(self.name())

		return None
	      

	# specific to this gadget
	_collapsed       = True
	
	# specific gadget attibutes
	# NONE
	
	# ---------------------------------
	
	# access
	      
	def isCollapsed(self):
	  
		''''Return if the nitial state is collapsed'''
		return self._collapsed
      
      
	# ---------------------------------

	      
	def setIsCollapsed(self, true_or_false):

		'''Set if the nitial state is collapsed
		
		   Also affects the value
		   This normally should not be of concern.'''
		
		collapsed = bool(true_or_false)
		
		self._collapsed = collapsed
		self.setValue(abs(1-collapsed))

		return None
