# ==============================================================================
#                Enumerations used in uiScriptPy classes
#  ----------------------------------------------------------------------------
# ==============================================================================

from utils import __uiScriptEnum

# top level gadgets
uiScriptGadgetType       = __uiScriptEnum('menubutton','button', 'menu', 'slider', 'container', 'window', 'dialog', 'toggle', 'string',
                                 'float', 'int', 'separator', 'field', 'label', 'file', 'color', 'icon', prefix='uiScriptGadgetType')

# attributes
uiScriptLayout           = __uiScriptEnum('horizontal', 'vertical', 'overlap', 'cell', prefix='uiScriptLayout')
uiScriptLook             = __uiScriptEnum('plain', 'line', 'groove', 'bevel', 'beveldown', prefix='uiScriptLook')
uiScriptJustifyHoriz     = __uiScriptEnum('left', 'center', 'right', prefix='uiScriptJustifyHoriz')
uiScriptJustifyVert      = __uiScriptEnum('top','center', 'bottom', prefix='uiScriptJustifyVert')
uiScriptIconButtonSize   = __uiScriptEnum('large', 'small', 'tiny', 'micro', prefix='uiScriptIconButtonSize')

# containers
uiScriptContainerType    = __uiScriptEnum('scroller', 'toolscroller', 'switcher', 'splitparent', 'opennotifier', 'stowbar',
                                'collapser', 'row', 'col', 'buttonstrip', 'icon_botton_strip', 'icon_radio_strip',
                                'icon_onemax_strip','icon_strip_group', 'tab', 'tabdialog', prefix='uiScriptContainerType')
                                
uiScriptFolderType       = __uiScriptEnum('switcher', prefix='uiScriptFolderType')
uiScriptTabsType         = __uiScriptEnum('radio', 'shelf', 'pane', 'default', prefix='uiScriptTabsType') # should this be folder? doesit replace switcher?
uiScriptScrollerType     = __uiScriptEnum('scroller', 'toolscroller', prefix='uiScriptScrollerType')
uiScriptStripType        = __uiScriptEnum('normal', 'radio', 'bitmap', 'onemax', prefix='uiScriptStripType')
uiScriptBasicContainerType   = __uiScriptEnum('row', 'col', 'collapser', prefix='uiScriptBasicContainerType')
## stowbar, opennotifier cell???

# gadgets
uiScriptMenuType         = __uiScriptEnum('action', 'select', prefix='uiScriptMenuType')
uiScriptWindowType       = __uiScriptEnum('normal', 'dialog', prefix='uiScriptWindowType')
uiScriptButtonType       = __uiScriptEnum('action', 'toggle', prefix='uiScriptButtonType')

uiScriptStringType      = __uiScriptEnum('string', 'alphanum', 'string_menu', 'password', prefix='uiScriptStringType')
#uiScriptStringType      = __uiScriptEnum('string', 'alphanum', 'string_limited', 'string_menu', 'password', prefix='uiScriptStringType')
uiScriptStringReplaceType = __uiScriptEnum('replace', 'append', 'appendwild', prefix='uiScriptStringReplaceType')

uiScriptTextLook        = __uiScriptEnum('bold', 'plain', 'underline', 'title', 'fineprint', 'line', 'heading', 'paper', 'paperline', 'circle', 'light', 'lightline', 'icon', prefix='uiScriptTextLook')#**** trial and err some common ones
uiScriptLabelType       = __uiScriptEnum('label', 'squishy_label', prefix='uiScriptLabelType')

uiScriptFileType        = __uiScriptEnum('all', 'pic', 'picseq', 'geo', 'geoseq', 'chan', 'audio', 'script', 'otl', 'hip', prefix='uiScriptFileType')
#uiScriptIntType         = __uiScriptEnum('field', 'slider', 'slider_field', 'spinner_field', 'vector_field', prefix='uiScriptIntType')
uiScriptNumType         = __uiScriptEnum('field', 'slider', 'slider_field', 'spinner_field', 'vector_field', prefix='uiScriptNumType')
uiScriptColorType       = __uiScriptEnum('color', 'color_alpha', prefix='uiScriptColorType')
uiScriptScrollerType    = __uiScriptEnum('scroller', 'toolscroller', prefix='uiScriptScrollerType')
uiScriptDirection       = __uiScriptEnum('horizontal', 'vertical', 'full', prefix='uiScriptDirection')
uiScriptSeparatorLook   = __uiScriptEnum('darkline', 'underline', 'lightline', 'paperline', 'indent', 'circle', 'paper',
                                'bevel', 'bevel2', 'groove', 'splitbar', prefix='uiScriptSeparatorLook')

# utilities these are less literal and conveniances
uiScriptNamingScheme    = __uiScriptEnum('Base1', 'BeginEnd', 'MaxMin', 'MinMax', 'RGBA', 'StartEnd', 'UVW', 'XYWH', 'XYZW' , prefix='uiScriptNamingScheme')