# ==============================================================================
#                File used in uiScriptPy Lib
#  ----------------------------------------------------------------------------
#  file fields and related combines UI script ...
#      FILE_FILED 
# ==============================================================================

from enums        import *
from base_classes import *

import utils


class FileUiScriptGadget(UiScriptGadget):

	def __init__(self, name, label=None): 

		self.setName(name)
		self.setLabel(label)
		
		self._value   = ''

		return None


	#def __repr__(self):
		#pass

	# for declaration
	_type          = uiScriptGadgetType.file
	_file_filter   = uiScriptFileType.all

	# specific to this gadget
	_label           = None
	_label_width     = None ## check if this works

	# specific gadget attibutes

	# ---------------------------------

	# access
	
	def label(self):
	  
		'''Return label diplayed as a string'''
		return self._label

		
	def labelWidth(self):
	  
		'''Return the width of label displayed'''
		return self._label_width

		
	def fileFilterByType(self):
	  
		'''Returns an emumeration for file filtering'''
		return _file_filter
		
	# ---------------------------------
	
	
	def setLabel(self, label):
	  
		'''Set string for label diplayed '''
		
		self._label = label
		return None

		
	def setLabelWidth(self, label_width):
	  
		'''Set the width of label displayed'''
	  
		if label_width == None:
		  
			self._label_width = None	
		else :
			self._label_width = float(label_width)
			
		return None
	  
	      
	def setFileFilterByType(self, uiScriptFileType):
	  
		'''Set an emumeration for file filtering'''
	  
		self._file_filter = uiScriptFileType
		return None

	# ---------------------------------

	def _printDeclarations(self):

		# value declaration 
		if self._printOkay(self._value):
			value = str(self._value)
		else:
			value = ''

		# value declaration
		names = utils._gadgetTemplateNamesTuple(
		                                        self.name(),
		                                        self.namingScheme(),
		                                        self.numComponents()
		                                        )

		val_decl = names[0] + ':= "' + value +'";'
		
		# gadget declaration
		gadget_decl = self._name + '.gad ='

		gadget_decl += ' FILENAME_FIELD'
		
		# specify the filter type
		file_filter = self._file_filter.name()
		gadget_decl += '(' + file_filter + ')'

		# add the label if one has bween set
		if self._printOkay(self._label):
			gadget_decl += ' "'+self._label +'"'
		
			# print label width if required
			if self._printOkay(self._label_width):
				gadget_decl += ':' + str(self._label_width)

		# add the value attribute to declaration
		gadget_decl += ' VALUE(' + self._name + '.val)'	

		all_attribs = self._printAllAttributes()
		cmds        = self._printCmds()

		result = val_decl +'\n'+ gadget_decl +' '+all_attribs+';\n'+cmds

		return result

	

	def _printGadgetAttributes(self):

		gadget_attribs = [
			          #,
			          #,
			          #
			         ]
		result = [i for i in gadget_attribs if i !=None]
		return result
