# ==============================================================================
#           tab containers class used in uiScriptPy module
#  ----------------------------------------------------------------------------
#  
#  Combine uiScript TAB
# ==============================================================================


# deal with the type/container type, tab type etc....

from   enums        import *
import utils
from   base_classes import *
from   container_class import*

class TabUiScriptContainer(UiScriptContainer):



	def __init__(self, name, uiScriptGadgets=(), label=None):#, tab_type=uiScriptTabType.default):

		self._name                 = name
		self._children             = uiScriptGadgets
		#self._tab_type             = tab_type
		self._container_type       = uiScriptContainerType.tab
		self._value                = 0

		if label == None: self._label = self._name # label rquired
		
		return None
		
	# for declaration
	_children             = ()
	#_tab_type             = None
	_container_type       = None
	_type                 = uiScriptGadgetType.container


	# specific to this gadget
	_label        = None
	_label_width  = None
	
	# specific gadget attibutes

	# ---------------------------------
	

	def label(self):
		return self._label
	
	def labelWidth(self):
		return self._label_width
		
	#def tabType(self):
		#return self._tab_type
		
	# ---------------------------------
	

	def setLabel(self, label):
		self._label = label
		return None
		
	def setLabelWidth(self, label_width):
		self._label_width = float(label_width)
		return None
		
	#def setTabType(self, uiScriptTabType):
		#self._tab_type = uiScriptTabType)
		#return None
		
	# ---------------------------------
	
	def _printDeclarations(self):
	# prints the container declaration with refs to children
	
		# value declaration 
		val_decl = self._name + '.val:= ' + str(self._value) + ';'

		# gadget declaration
		gadget_decl = self._name + '.gad ='
		
		container_type = (self._container_type.rsplit('.', 1)[-1]).upper()
		gadget_decl +=  ' ' + container_type
		
		#if self._container_type == uiScriptTabType.collapser:
		
		if self._printOkay(self._label): ## check if label IS require -- probably .... 
			gadget_decl +=  ' "'+ self._label + '"'
		
			# print label width if required
			if self._printOkay(self._label_width):
				gadget_decl += ':' + str(self._label_width)
				
		# value atrrib goes on a seperate line
		val_attrib  = 'VALUE(' + self._name + '.val)\n'	

		all_attribs = self._printAllAttributes()
		all_attribs = '    ' + val_attrib + '    ' +all_attribs
		
		gadget_refs = [x._name + '.gad;\n' for x in self._children]
		gadget_refs_string = '    ' + ('    '.join(gadget_refs) )
		
		gadget_decl += '\n{\n' + all_attribs + '\n\n' + gadget_refs_string + '}'

		# commands
		cmds        = self._printCmds()

		# resulting string
		result = val_decl + '\n' + gadget_decl +'\n'+cmds
		
		return result

