# ==============================================================================
#                utilities used in uiScriptPy module
#  ----------------------------------------------------------------------------
# ==============================================================================

def _isGadget(testObject):
	
	#if not any([
	if any([
		'UiScriptGadget' in str(testObject),
		'UiScriptContainer' in str(testObject)
		]): 
		result = True
	else:
		result =  False
		
	return result


def _isContainer(testObject):

	if 'UiScriptContainer' in str(testObject): 
		result =  True
	else:
		result = False
		
	return result


def _isWindow(testObject):

	if 'UiScriptWindow' in str(testObject): 
		result = true
	else:
		result = False
		
	return result

      
class UiscriptEnumValue(object):
  
	def __init__(self, name, index, prefix=None, long_name=True, val_is_idx=False):
	  
		self.__name = name
		self.__index = index
		self.__prefix = prefix
		self.__long = long_name
		self.__val_is_idx = val_is_idx
		
		return None


	def __repr__(self):
		
		represnt = self.__str_val()
		return represnt


	__name=None
	__index=None
	__prefix=None
	__long = None
	__val_is_idx =None


	def name(self):
		return self.__name
	      
	def index(self):
		return self.__index
	      

	def __str_val(self):
	  
		result = None
		
		if self.__val_is_idx == True:
			result = str(self.index())
			
		elif any([
		          self.__prefix == None,
		          self.__long == False,
		          ]):
		  
			result = str(self.name())
			
		else: result = str(self.__prefix) + '.' + str(self.name())
		
		return result
	      



def __uiScriptEnum(*sequential, **named):

	'''long_name=True, prefix=None, val_is_idx=False, sort=False):'''
  
	if named.has_key('prefix'):
		prefix = named['prefix']
	else: prefix = None
	
	if named.has_key('long_name'):
		long_name=named['long_name']
	else: long_name=None
		
	if named.has_key('val_is_idx'):
		val_is_idx=named['long_name']
	else: val_is_idx=False
	
	if named.has_key('sort'):
		sort = named['sort']
	else: sort = False
	
	names = list(sequential)
	if sort == True: 
		names.sort()
	
	enum_val_dict = {}
	for i in range(len(names)):
  
		name=names[i]
		enum_val = UiscriptEnumValue(
		                             name=name,
		                             index=i,
		                             prefix=prefix,
		                             long_name=long_name,
		                             val_is_idx=val_is_idx
		                            )
		enum_val_dict[name] = enum_val
		
	return type('UiScriptPyEnum', (), enum_val_dict)
	#enum = type('UiScriptPyEnum', (), enum_val_dict)
	#enum.value = foo()

def _isEnumMember(enum, name):
  
	all_members =[ x for x in dir(enum) if x.startswith('_') is False ]
	result = name in all_members
	return result
      

def _namingSchemeToSuffixList(uiScriptNamingScheme, gadget_size):

      # BELOW IS FROM THE DOC FOR THE PARM ENUMERATION
      # BEST TO KEEP WITH CONVENTION
      
      #T he following restrictions exist on naming schemes:

      # * You cannot use the following naming schemes when editing the parameter
	# interface on a node or a digital asset: MinMax, MaxMin, StartEnd,
	# BeginEnd, XYWH.  However, some built-in node types use parameters with
	# these naming schemes, so asking these node types for their parm
	# templates may return ones using these naming schemes.
      # * String and toggle parameters only support the Base1 naming scheme.
      # * Parameters with the hou.parmLook.Vector look must use the XYZW naming
	# scheme.
      # * Parameters with the hou.parmLook.Angle look must use the Base1 naming
	# scheme.
      # * Parameters with the hou.parmLook.ColorSquare look must use an RGBA
	# naming scheme.
	
	translate_dict = {}
	
	translate_dict['Base1']    = [str(x + 1) for x in range(gadget_size)]
	translate_dict['BeginEnd'] = ['begin', 'end'][0:gadget_size]
	translate_dict['MaxMin']   = ['max', 'min'][0:gadget_size]
	translate_dict['MinMax']   = ['min', 'max'][0:gadget_size]
	translate_dict['RGBA']     = list('rgba')[0:gadget_size]
	translate_dict['StartEnd'] = ['start', 'end'][0:gadget_size]
	translate_dict['UVW']      = list('uvw')[0:gadget_size]
	translate_dict['XYWH']     = list('xywh')[0:gadget_size]
	translate_dict['XYZW']     = list('xyzw')[0:gadget_size]
	
	result = translate_dict[uiScriptNamingScheme.name()]
	return result


def _gadgetNamesTuple(name, uiScriptNamingScheme, gadget_size):
  
	# used for predictable naming for Gadget instances
	# when using only one comonant does not add suffixes
	
	results = None
	
	if gadget_size > 1:
		suffixes = _namingSchemeToSuffixList(
	                                             uiScriptNamingScheme,
	                                             gadget_size)
		
		names = [ name + x for x in suffixes ]
		results = tuple(names)
	else:
		results = (name,)

	return results


def _gadgetTemplateNamesTuple(name, uiScriptNamingScheme, gadget_size):
  
	# used for predictable naming for uiScriptGadget instances
	# when using only one comonant does not add suffixes

	results = None
	
	if gadget_size > 1:
		suffixes = _namingSchemeToSuffixList(
	                                             uiScriptNamingScheme,
	                                             gadget_size)
		
		names = [ name + '.' + x + '.val'  for x in suffixes ]
		results = tuple(names)
	else:
		results = (name + '.val',)
		
	return results

  
#def foo():
	#return ['aaaaaa','bbbbb','ccccccc']

#def _returnFromNameGadgetOrIndex(gadgets, testObject):
	
	## default result
	#result = None
	
	## when a index ...
	#if type(testObject) == type(int()):
		#reuslt = gadgets[testObject]
		
	## when a name
	#elif  type(testObject) == type(str()):
		#for gadget in gadgets:
			#if gadget.name() == testObject():
				#result = gadget
				#break
			#else : continue
		
	## when an object ...
	
	
		
	#return result
